
	RLaB Contributors Form

	If you are developing rfiles that you wish to share with
	others or contribute to the RLaB distribution, please fill out
	this form and mail it to ians@eskimo.com. 

	Likewise, before you begin development, it would be good to
	check and see if others are working on the same or similar
	projects. If you want to know what is currently "in-work",
	send mail to ians@eskimo.com and you will receive a copy of
	the contributor's database.

	-------------------- Contributor's Form ----------------------

	Project Name:

	Technical Subject Area:

	Application Area(s):

	Author's Name:
	Author's e-mail:

	Rfile Name(s):

	Description:

	-------------------- Contributor's Form ----------------------

	At the bottom is the "suggested" form for documentation of
	rfiles.  No one will change your work if you do not follow
	this format.

	If this form is not adequate, then please send suggestions to
	ians@eskimo.com

	Enjoy,
	Ian Searle
	ians@eskimo.com

//-------------------------------------------------------------------//

// Synopsis:	Band reduction by two-sided unitary transformations.

// Syntax:	bandred ( A , KL, KU )

// Description:

//	bandred(A, KL, KU) is a matrix unitarily equivalent to A with
//	lower bandwidth KL and upper bandwidth KU (i.e. B(i,j) = 0 if
//	i > j+KL or j > i+KU).  The reduction is performed using
//	Householder transformations. If KU is omitted it defaults to
//	KL. 

//	Called by randsvd.
//	This is a `standard' reduction.  Cf. reduction to bidiagonal
//	form prior to computing the SVD.  This code is a little
//	wasteful in that it computes certain elements which are
//	immediately set to zero! 
//
//      Reference:
//      G.H. Golub and C.F. Van Loan, Matrix Computations, second edition,
//      Johns Hopkins University Press, Baltimore, Maryland, 1989.
//      Section 5.4.3.

//	This file is a translation of bandred.m from version 2.0 of
//	"The Test Matrix Toolbox for Matlab", described in Numerical
//	Analysis Report No. 237, December 1993, by N. J. Higham.

// Dependencies
   rfile house

//-------------------------------------------------------------------//

